#include "obj05_db_api.h"
#include "obj05_db_dbd.h"

using namespace RDM_CPP;

Db_obj05_db Db_obj05_db::Open (char *mode) throw (rdm_exception&) {
    return Db::Open (Type (), "obj05_db", mode, &obj05_db_dbd, sizeof(obj05_db_dbd));
}

#if !defined(RDM_NO_UNICODE)
Db_obj05_db Db_obj05_db::Open (wchar_t *mode) throw (rdm_exception&) {
    return Db::Open (Type (), L"obj05_db", mode, &obj05_db_dbd, sizeof(obj05_db_dbd));
}
#endif /*RDM_NO_UNICODE*/

Db_obj05_db Db_obj05_db::Open (const char *name, const char *mode) throw (rdm_exception&) {
    return Db::Open (Type (), name, mode, &obj05_db_dbd, sizeof(obj05_db_dbd));
}

#if !defined(RDM_NO_UNICODE)
Db_obj05_db Db_obj05_db::Open (const wchar_t *name, const wchar_t *mode) throw (rdm_exception&) {
    return Db::Open (Type (), name, mode, &obj05_db_dbd, sizeof(obj05_db_dbd));
}
#endif /*RDM_NO_UNICODE*/

dbType Db_obj05_db::Type (void) {
    char static type;
    return &type;
}

Db_obj05_db::Db_obj05_db (void) throw () {
}

Db_obj05_db::Db_obj05_db (const Db& db) throw () : Db (db, Type()) {
}

Db_obj05_db::Db_obj05_db (const Db_obj05_db& db) throw () : Db (db) {
}

Db_obj05_db::Db_obj05_db (IDb *idb) : Db (idb) {
}

Db_obj05_db& Db_obj05_db::operator = (const Db& db) throw (rdm_exception&) {
    AssignAndVerifyType (Type (), db);
    return *this;
}

Db_obj05_db& Db_obj05_db::operator = (const Db_obj05_db& db) throw () {
    *((Db *)this) = db;
    return *this;
}

Db_obj05_db::~Db_obj05_db () {
}

Cursor_person Db_obj05_db::New_person_record (void) const throw (rdm_exception&) {
    return Cursor_person (NewRecords (Cursor_person::Type ()));
}

Cursor_person Db_obj05_db::New_person_recordWithFieldValues (struct person *fields) const throw (rdm_exception&) {
    return Cursor_person (NewRecordsWithFieldValues (Cursor_person::Type (), fields));
}

Cursor_person Db_obj05_db::Get_person_records (void) const throw (rdm_exception&) {
    return Cursor_person (GetRecords (Cursor_person::Type ()));
}

Cursor_person Db_obj05_db::Get_person_recordsBy_last_four_ssn () const throw (rdm_exception&) {
    return Cursor_person (GetRecordsByKey (LAST_FOUR_SSN));
}

recordType Cursor_person::Type (void) {
    return PERSON;
}

Cursor_person::Cursor_person (void) throw () {
}

Cursor_person::Cursor_person (const Cursor& cursor) throw (rdm_exception&) : Cursor (cursor, Type ()) {
}

Cursor_person::Cursor_person (const Cursor_person& cursor) throw () : Cursor (cursor) {
}

Cursor_person& Cursor_person::operator = (const Cursor& cursor) throw (rdm_exception&) {
    AssignAndVerifyType (Type (), cursor);
    return *this;
}

Cursor_person& Cursor_person::operator = (const Cursor_person& cursor) throw () {
    *((Cursor *)this) = cursor;
    return *this;
}

Cursor_person Cursor_person::GetRecordsBy_last_four_ssn () const throw (rdm_exception&) {
    return Cursor_person (GetRecordsByKey (LAST_FOUR_SSN));
}

void Cursor_person::KeyFindBy_last_four_ssn (char last_four_ssn_val[5]) const throw (rdm_exception&) {
    FindRecordsByKey(LAST_FOUR_SSN, 0, 0, last_four_ssn_val);
}

void Cursor_person::SetFieldValues (const struct person *fields) const throw (rdm_exception&) {
    Cursor::SetFieldValues (Type (), fields);
}

void Cursor_person::GetFieldValues (struct person *fields) const throw (rdm_exception&) {
    Cursor::GetFieldValues (Type (), fields);
}

void Cursor_person::Set_last_four_ssn (const char last_four_ssn_val[5]) const throw (rdm_exception&) {
    SetField (LAST_FOUR_SSN, last_four_ssn_val);
}

void Cursor_person::Get_last_four_ssn (char last_four_ssn_val[5]) const throw (rdm_exception&) {
    GetField (LAST_FOUR_SSN, last_four_ssn_val);
}

Cursor_person::~Cursor_person () {
}

